/*
Started on 7/15/06 as Squadron
Restarted in 2007 as Fleet Command
Restarted on 3/13/08 as Asp

Finished on 5/30/08
*/

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Date;
import javax.swing.*;
import javax.swing.SwingUtilities;
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.io.*;

public class AspGame extends JFrame
{
	long times=0;
	double fps = 0.0;
	   
	private BufferedImage image;
	public static Battle b = new Battle();
	public Timer t = new Timer (0, new Listener());
	public Graphics2D g;
	int mouseX = 400, mouseY = 300;
	public Color myPurple = new Color(0.5f, 0, 0.5f);

	public boolean leftClicked = false;
	public boolean rightClicked = false;
	public boolean leftMousePressed = false;
	public boolean rightMousePressed = false;
	public boolean deleteTyped = false;
	public boolean rightTyped = false;
	public boolean leftTyped = false;
	public boolean spaceTyped = false;
	public boolean escapeTyped = false;

	public int tutorial = 0;
	public boolean turnOver = false;
	public boolean battleMenu = false;
	public boolean pausedSaved = false;
	public String title = "MENU";
	public boolean campaign = false;
	public boolean displaySquadInfo = false;
	public int displaySquadX = 0;
	public int displaySquadY = 0;

	public int sizeRight=800, sizeTop=600;
	public int currentSquadNum = 0;
	public JFrame fm;
	public FontMetrics fontmet;

	//state enums
	public enum Mode { MAINMENU, STORY, BATTLE }
	public Mode mode = Mode.MAINMENU;

	public enum StoryScene { STORY11, STORY12, STORY13, STORY21, STORY31, STORY41, STORY51, STORY61 }
	public StoryScene scene = StoryScene.STORY11;

	public enum MenuScreen { TITLE, MAINMENU, GAMEINFO, CREDITS, SKIRMISH }
	public MenuScreen screen = MenuScreen.TITLE;
	   
	public BufferedImage background = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background1 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background2 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background3 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background4 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background5 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background6 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background7 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background8 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background9 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background10 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background11 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage background12 = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
	public BufferedImage menu = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage titlescreen = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage gameinfo = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage credits = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story11 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story12 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story13 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story21 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story31 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story41 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story51 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
	public BufferedImage story61 = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);

	public BufferedImage crosshair = new BufferedImage(32, 32, BufferedImage.TYPE_INT_ARGB);

	public BufferedImage pFighterImg = new BufferedImage(15, 15, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage pScramblerImg = new BufferedImage(10, 10, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage pBomberImg = new BufferedImage(15, 15, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage pResilientImg = new BufferedImage(20, 20, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage pAspImg = new BufferedImage(50, 50, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eFighterImg = new BufferedImage(15, 15, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eBomberImg = new BufferedImage(20, 20, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eEliteImg = new BufferedImage(20, 20, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eStationImg = new BufferedImage(40, 40, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eCannonImg = new BufferedImage(40, 40, BufferedImage.TYPE_INT_ARGB);

	public BufferedImage pBombImg = new BufferedImage(10, 10, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage pShotImg = new BufferedImage(5, 5, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eShotImg = new BufferedImage(5, 5, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eBombImg = new BufferedImage(10, 10, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eShellImg = new BufferedImage(10, 10, BufferedImage.TYPE_INT_ARGB);

	public BufferedImage explosionSmallImg = new BufferedImage(20, 20, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage explosionLargeImg = new BufferedImage(50, 50, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage bloodSmallImg = new BufferedImage(20, 20, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage eDebris = new BufferedImage(5, 5, BufferedImage.TYPE_INT_ARGB);
	public BufferedImage pDebris = new BufferedImage(5, 5, BufferedImage.TYPE_INT_ARGB);

	public static BufferStrategy strategy;


	public AspGame() throws Exception
	{
		setSize(800, 600);
		setLocation(200, 100);
		//setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);

		createBufferStrategy(2);
		strategy = getBufferStrategy();

		//initialize input listeners
		addMouseListener(new MouseInputHandler());
		addMouseMotionListener(new MouseMotionHandler());
		addKeyListener(new KeyInputHandler());
		setFocusable(true);
		requestFocusInWindow();


		initImages(); //load images

		//set up main image
		image = new BufferedImage(sizeRight, sizeTop, BufferedImage.TYPE_INT_RGB);
		g = image.createGraphics();
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
		g.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
		g.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
		g.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
		g.setRenderingHint(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_ENABLE);        												
		g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		
		g.setFont(new Font("Serif", Font.BOLD, 20));
		fontmet = g.getFontMetrics();
		
		t.start();
	}

	public static void main(String[] args) throws Exception
	{
		JFrame frame = new AspGame();
	}

	private void initImages()
	{
		try
		{
			Graphics2D g2;
			background.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/background.png")),0,0,this);
			menu.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/menu.png")),0,0,this);
			titlescreen.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/title.png")),0,0,this);
			credits.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/credits.png")),0,0,this);
			gameinfo.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/gameinfo.png")),0,0,this);
			story11.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story11.png")),0,0,this);
			story12.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story12.png")),0,0,this);
			story13.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story13.png")),0,0,this);
			story21.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story21.png")),0,0,this);
			story31.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story31.png")),0,0,this);
			story41.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story41.png")),0,0,this);
			story51.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story51.png")),0,0,this);
			story61.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/story61.png")),0,0,this);
			pScramblerImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/pscrambler.png")),0,0,this);
			pFighterImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/pfighter.png")),0,0,this);
			pBomberImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/pbomber.png")),0,0,this);
			pResilientImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/presiliant.png")),0,0,this);
			pAspImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/pasp.png")),0,0,this);
			eFighterImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/efighter.png")),0,0,this);
			eBomberImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eBomber.png")),0,0,this);
			eEliteImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eelite.png")),0,0,this);
			eStationImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eStation.png")),0,0,this);
			eCannonImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eCannon.png")),0,0,this);
			pBombImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/pBomb.png")),0,0,this);
			pShotImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/pShot.png")),0,0,this);
			eBombImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eBomb.png")),0,0,this);
			eShotImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eShot.png")),0,0,this);
			eShellImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eShell.png")),0,0,this);
			explosionSmallImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/explosionsmall.png")),0,0,this);
			explosionLargeImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/explosionlarge.png")),0,0,this);
			bloodSmallImg.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/bloodsmall.png")),0,0,this);
			pDebris.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/pDebris.png")),0,0,this);
			eDebris.createGraphics().drawImage(ImageIO.read(getClass().getResource("assets/eDebris.png")),0,0,this);
		}
		catch(Exception ex)
		{
			System.out.println("Image Loading Error");
			System.exit(1);
		}
	
	}

	public void paintAll()
	{
		do 
		{
			do 
			{
				Graphics graphics = strategy.getDrawGraphics();
				graphics.drawImage(image,0,0,null);
				graphics.dispose();

			} while (strategy.contentsRestored());

			strategy.show();

		} while (strategy.contentsLost()); 
	}

	private void tick(int step)
	{
		switch(mode)
		{
			case MAINMENU: tickMenu(); break; 
			case STORY: tickStory(); break;
			case BATTLE: tickBattle(step); break;
		}

		// reset input
		leftClicked = false;
		rightClicked = false; 
		leftTyped = false;
		rightTyped = false;
		deleteTyped = false;
		spaceTyped = false;
		escapeTyped = false;
	}

	private void tickMenu()
	{
		FontMetrics fmetric;
		switch(screen)
		{
			case TITLE: g.drawImage(titlescreen,0,0,this); if(leftClicked) { screen = MenuScreen.MAINMENU; } break; 
			case MAINMENU: 
				g.drawImage(menu,0,0,this);
				// menu title
				g.setFont(new Font("SANS_SERIF", Font.BOLD, 60));
				fmetric = g.getFontMetrics();
				g.setColor(myPurple);
				g.drawString("MENU", 400-(fmetric.stringWidth("MENU") / 2), 100);

				g.setFont(new Font("SANS_SERIF", Font.BOLD, 40));
				fmetric = g.getFontMetrics();
				g.setColor(myPurple);

				if(mouseY > 165 && mouseY < 210) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						mode = Mode.STORY; 
						campaign = true; 
						scene = StoryScene.STORY11;
					} 
				}
				g.drawString("Play Campaign", 400-(fmetric.stringWidth("Play Campaign") / 2), 200);
				g.setColor(myPurple);
				
				if(mouseY > 215 && mouseY < 260) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						screen = MenuScreen.SKIRMISH; 
						campaign = false;
					} 
				}
				g.drawString("Skirmish", 400-(fmetric.stringWidth("Skirmish") / 2), 250);
				g.setColor(myPurple);

				if(mouseY > 265 && mouseY < 310) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						screen = MenuScreen.GAMEINFO; 
					} 
				}
				g.drawString("Game Info", 400-(fmetric.stringWidth("Game Info") / 2), 300);
				g.setColor(myPurple);

				if(mouseY > 315 && mouseY < 360) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						mode = Mode.BATTLE; tutorial = 1; 
						b = new Battle(); 
						b.eSquads.add(new eSquad(700, 75, 2, eBomberImg)); 
						pSquad ps = new pSquad(100, 525, 2, Color.RED, pFighterImg);
						ps.waypoints.add(new Waypoint(650.0,100.0));
						b.pSquads.add(ps);
					} 
				} 
				g.drawString("Tutorial", 400-(fmetric.stringWidth("Tutorial") / 2), 350);
				g.setColor(myPurple);

				if(mouseY > 365 && mouseY < 410) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						screen = MenuScreen.CREDITS; 
						campaign = false;
					} 
				}
				g.drawString("Credits", 400-(fmetric.stringWidth("Credits") / 2), 400);
				g.setColor(myPurple);

				if(mouseY > 415 && mouseY < 460) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						System.exit(0); 
					} 
				}
				g.drawString("Exit", 400-(fmetric.stringWidth("Exit") / 2), 450);
				break;

			case SKIRMISH:
				g.drawImage(menu,0,0,this);
				// menu title
				g.setFont(new Font("SANS_SERIF", Font.BOLD, 60));
				fmetric = g.getFontMetrics();
				g.setColor(myPurple);
				g.drawString("SKIRMISH", 400-(fmetric.stringWidth("SKIRMISH") / 2), 100);

				g.setFont(new Font("SANS_SERIF", Font.BOLD, 40));
				fmetric = g.getFontMetrics();
				g.setColor(myPurple);

				if(mouseY > 165 && mouseY < 210) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						startRandom(750); 
					} 
				}
				g.drawString("Small Battle", 400-(fmetric.stringWidth("Small Battle") / 2), 200);
				g.setColor(myPurple);

				if(mouseY > 215 && mouseY < 260) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						startRandom(1100); 
					} 
				}
				g.drawString("Standard Battle", 400-(fmetric.stringWidth("Standard Battle") / 2), 250);
				g.setColor(myPurple);

				if(mouseY > 265 && mouseY < 310) 	
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						startRandom(1500); 
					} 
				}
				g.drawString("Large Battle", 400-(fmetric.stringWidth("Large Battle") / 2), 300);
				g.setColor(myPurple);

				if(mouseY > 315 && mouseY < 360) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						startMany(); 
					} 
				} 
				g.drawString("The Many", 400-(fmetric.stringWidth("The Many") / 2), 350);
				g.setColor(myPurple);

				if(mouseY > 365 && mouseY < 410) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						startFew(); 
					} 
				}
				g.drawString("The Few", 400-(fmetric.stringWidth("The Few") / 2), 400);
				g.setColor(myPurple);

				if(mouseY > 415 && mouseY < 460) 
				{ 
					g.setColor(Color.WHITE); 
					if(leftClicked) 
					{ 
						screen = MenuScreen.MAINMENU; 
					} 
				}
				g.drawString("Back", 400-(fmetric.stringWidth("Back") / 2), 450);
				break;

			case GAMEINFO: 
				g.drawImage(gameinfo,0,0,this);
				if(leftClicked) 
					screen = MenuScreen.MAINMENU;
				break;
			case CREDITS: 
				g.drawImage(credits,0,0,this);
				if(leftClicked) 
					screen = MenuScreen.MAINMENU;
				break;

		}
		
		paintAll();
	}

	private void randomAddpSquad(int type, Color mycolor)
	{
		switch(type)
		{
			case 1:
				b.pSquads.add(new pSquad((int)(Math.random()*700+50), (int)(Math.random()*50+500), 1, mycolor, pScramblerImg));
				break;
			case 2:
				b.pSquads.add(new pSquad((int)(Math.random()*700+50), (int)(Math.random()*50+500), 2, mycolor, pFighterImg));
				break;
			case 3:
				b.pSquads.add(new pSquad((int)(Math.random()*700+50), (int)(Math.random()*50+500), 3, mycolor, pBomberImg));
				break;
			case 4:
				b.pSquads.add(new pSquad((int)(Math.random()*700+50), (int)(Math.random()*50+500), 4, mycolor, pResilientImg));
				break;
			case 5:
				b.pSquads.add(new pSquad((int)(Math.random()*700+50), (int)(Math.random()*50+500), 5, mycolor, pAspImg));
				break;
		}
	}

	private void randomAddeSquad(int type)
	{
		switch(type)
		{
			case 1:
				b.eSquads.add(new eSquad((int)(Math.random()*700+50), (int)(Math.random()*50+50), 1, eFighterImg));
				break;
			case 2:
				b.eSquads.add(new eSquad((int)(Math.random()*700+50), (int)(Math.random()*50+50), 2, eBomberImg));
				break;
			case 3:
				b.eSquads.add(new eSquad((int)(Math.random()*700+50), (int)(Math.random()*50+50), 3, eEliteImg));
				break;
			case 4:
				b.eSquads.add(new eSquad((int)(Math.random()*700+50), (int)(Math.random()*50+150), 4, eStationImg));
				break;
			case 5:
				b.eSquads.add(new eSquad((int)(Math.random()*700+50), (int)(Math.random()*50+150), 5, eCannonImg));
				break;
		}
	}

	private void startRandom(int crowd)
	{
		int pcrowd = crowd;
		int ecrowd = crowd;
		double choice;
		mode = Mode.BATTLE;
		scene = StoryScene.STORY11; 
		b = new Battle();
		
		LinkedList<Color> squadColors = new LinkedList<Color>();
		squadColors.add(Color.RED);
		squadColors.add(Color.GREEN);
		squadColors.add(Color.BLUE);
		squadColors.add(Color.YELLOW);
		squadColors.add(Color.GRAY);
		squadColors.add(Color.CYAN);
		squadColors.add(Color.MAGENTA);
		squadColors.add(Color.ORANGE);
		Color currentColor;
		//add player squads
		while(pcrowd > pScrambler.svalue)
		{
			choice = Math.random(); //equal chances for all choices
			if(choice < .2)
			{
				if(pcrowd >= pScrambler.svalue)
				{
					pcrowd -= pScrambler.svalue;
					currentColor = squadColors.removeFirst();
					squadColors.addLast(currentColor.darker().darker());
					randomAddpSquad(1, currentColor);
				}
			}
			else if(choice < .4)
			{
				if(pcrowd >= pFighter.svalue)
				{
					pcrowd -= pFighter.svalue;
					currentColor = squadColors.removeFirst();
					squadColors.addLast(currentColor.darker().darker());
					randomAddpSquad(2, currentColor);
				}
			}
			else if(choice < .6)
			{
				if(pcrowd >= pBomber.svalue)
				{
					pcrowd -= pBomber.svalue;
					currentColor = squadColors.removeFirst();
					squadColors.addLast(currentColor.darker().darker());
					randomAddpSquad(3, currentColor);

				}
				
			}
			else if(choice < .8)
			{
				if(pcrowd >= pResilient.svalue)
				{
					pcrowd -= pResilient.svalue;
					currentColor = squadColors.removeFirst();
					squadColors.addLast(currentColor.darker().darker());
					randomAddpSquad(4, currentColor);

				}
				
			}
			else 
			{
				if(pcrowd >= pAsp.svalue)
				{
					pcrowd -= pAsp.svalue;
					currentColor = squadColors.removeFirst();
					squadColors.addLast(currentColor.darker().darker());
					randomAddpSquad(5, currentColor);

				}
				
			}
		}

		//add enemy squads
		while(ecrowd > eFighter.svalue)
		{
			choice = Math.random(); //equal chances for all choices
			if(choice < .2)
			{
				if(ecrowd >= eFighter.svalue)
				{
					ecrowd -= eFighter.svalue;
					randomAddeSquad(1);
				}
			}
			else if(choice < .4)
			{
				if(ecrowd >= eElite.svalue)
				{
					ecrowd -= eElite.svalue;
					randomAddeSquad(3);
				}
			}
			else if(choice < .6)
			{
				if(ecrowd >= eBomber.svalue)
				{
					ecrowd -= eBomber.svalue;
					randomAddeSquad(2);
				}
				
			}
			else if(choice < .8)
			{
				if(ecrowd >= eCannon.svalue)
				{
					ecrowd -= eCannon.svalue;
					randomAddeSquad(5);
				}
				
			}
			else 
			{
				if(ecrowd >= eStation.svalue)
				{
					ecrowd -= eStation.svalue;
					randomAddeSquad(4);
				}
				
			}
		}
		b.save();
	}

	private void startMany()
	{
		int pcrowd = 1500;
		int ecrowd = 1500;
		double choice;
		mode = Mode.BATTLE;
		scene = StoryScene.STORY11; 

		LinkedList<Color> squadColors = new LinkedList<Color>();
		squadColors.add(Color.RED);
		squadColors.add(Color.GREEN);
		squadColors.add(Color.BLUE);
		squadColors.add(Color.YELLOW);
		squadColors.add(Color.GRAY);
		squadColors.add(Color.CYAN);
		squadColors.add(Color.MAGENTA);
		squadColors.add(Color.ORANGE);
		Color currentColor;
		b = new Battle();

		//add player squads
		while(pcrowd > pScrambler.svalue)
		{
			if(pcrowd >= pScrambler.svalue)
			{
				pcrowd -= pScrambler.svalue;
				currentColor = squadColors.removeFirst();
				squadColors.addLast(currentColor.darker().darker());
				randomAddpSquad(1, currentColor);
			}
		}

		//add enemy squads
		while(ecrowd > eFighter.svalue)
		{
			choice = Math.random(); //equal chances for all choices
			if(choice < .2)
			{
				if(ecrowd >= eFighter.svalue)
				{
					ecrowd -= eFighter.svalue;
					randomAddeSquad(1);
				}
			}
			else if(choice < .4)
			{
				if(ecrowd >= eElite.svalue)
				{
					ecrowd -= eElite.svalue;
					randomAddeSquad(3);
				}
			}
			else if(choice < .6)
			{
				if(ecrowd >= eBomber.svalue)
				{
					ecrowd -= eBomber.svalue;
					randomAddeSquad(2);
				}
				
			}
			else if(choice < .8)
			{
				if(ecrowd >= eCannon.svalue)
				{
					ecrowd -= eCannon.svalue;
					randomAddeSquad(5);
				}
				
			}
			else 
			{
				if(ecrowd >= eStation.svalue)
				{
					ecrowd -= eStation.svalue;
					randomAddeSquad(4);
				}
				
			}
		}
		b.save();
	}

	private void startFew()
	{
		int pcrowd = 1500;
		int ecrowd = 1500;
		double choice;
		mode = Mode.BATTLE;
		scene = StoryScene.STORY11; 
		b = new Battle();

		LinkedList<Color> squadColors = new LinkedList<Color>();
		squadColors.add(Color.RED);
		squadColors.add(Color.GREEN);
		squadColors.add(Color.BLUE);
		squadColors.add(Color.YELLOW);
		squadColors.add(Color.GRAY);
		squadColors.add(Color.CYAN);
		squadColors.add(Color.MAGENTA);
		squadColors.add(Color.ORANGE);
		Color currentColor;

		//add player squads
		while(pcrowd >= pAsp.svalue)
		{
			if(pcrowd >= pAsp.svalue)
			{
				pcrowd -= pAsp.svalue;
				currentColor = squadColors.removeFirst();
				squadColors.addLast(currentColor.darker().darker());
				randomAddpSquad(5, currentColor);
			}
		}

		//add enemy squads
		while(ecrowd >= eFighter.svalue)
		{
			choice = Math.random(); //equal chances for all choices
			if(choice < .2)
			{
				if(ecrowd >= eFighter.svalue)
				{
					ecrowd -= eFighter.svalue;
					randomAddeSquad(1);
				}
			}
			else if(choice < .4)
			{
				if(ecrowd >= eElite.svalue)
				{
					ecrowd -= eElite.svalue;
					randomAddeSquad(3);
				}
			}
			else if(choice < .6)
			{
				if(ecrowd >= eBomber.svalue)
				{
					ecrowd -= eBomber.svalue;
					randomAddeSquad(2);
				}
			}
			else if(choice < .8)
			{
				if(ecrowd >= eCannon.svalue)
				{
					ecrowd -= eCannon.svalue;
					randomAddeSquad(5);
				}
				
			}
			else 
			{
				if(ecrowd >= eStation.svalue)
				{
					ecrowd -= eStation.svalue;
					randomAddeSquad(4);
				}
				
			}
		}
		b.save();
	}

	private void tickStory()
	{
		switch(scene)
		{
			case STORY11: g.drawImage(story11,0,0,this); if(leftClicked) { scene = StoryScene.STORY12; } break; 
			case STORY12: g.drawImage(story12,0,0,this); if(leftClicked) { scene = StoryScene.STORY13; } break;
			case STORY13: g.drawImage(story13,0,0,this); 

				if(leftClicked) 
				{
					scene = StoryScene.STORY21;
					mode = Mode.BATTLE; 
					//set up mission
					b = new Battle();
					b.pSquads.add(new pSquad(200, 550, 1, Color.RED, pScramblerImg));
					b.pSquads.add(new pSquad(350, 500, 2, Color.GREEN, pFighterImg));
					b.pSquads.add(new pSquad(450, 500, 2, Color.GRAY, pFighterImg));
					b.pSquads.add(new pSquad(600, 550, 1, Color.BLUE, pScramblerImg));

					b.eSquads.add(new eSquad(300, 100, 1, eFighterImg));
					b.eSquads.add(new eSquad(500, 100, 1, eFighterImg));

					b.save();
				} 
				break;
			case STORY21: g.drawImage(story21,0,0,this); 
				if(leftClicked) 
				{ 
					scene = StoryScene.STORY31;
					mode = Mode.BATTLE;
					//set up mission
					b = new Battle();
					b.pSquads.add(new pSquad(200, 525, 2, Color.BLUE, pFighterImg));
					b.pSquads.add(new pSquad(300, 550, 1, Color.CYAN, pScramblerImg));
					b.pSquads.add(new pSquad(400, 450, 4, Color.GRAY, pResilientImg));
					b.pSquads.add(new pSquad(400, 550, 2, Color.RED, pFighterImg));
					b.pSquads.add(new pSquad(500, 550, 1, Color.YELLOW, pScramblerImg));
					b.pSquads.add(new pSquad(600, 525, 2, Color.GREEN, pFighterImg));

					b.eSquads.add(new eSquad(150, 100, 1, eFighterImg));
					b.eSquads.add(new eSquad(650, 100, 1, eFighterImg));
					b.eSquads.add(new eSquad(450, 75, 3, eEliteImg));
					b.eSquads.add(new eSquad(350, 75, 3, eEliteImg));

					b.save();
				} 
				break;
			case STORY31: g.drawImage(story31,0,0,this); 
				if(leftClicked) 
				{
					scene = StoryScene.STORY41;
					mode = Mode.BATTLE; 
					//set up mission
					b = new Battle();

					b.pSquads.add(new pSquad(150, 550, 1, Color.CYAN, pScramblerImg));
					b.pSquads.add(new pSquad(250, 525, 2, Color.BLUE, pFighterImg));
					b.pSquads.add(new pSquad(375, 475, 3, Color.GRAY, pBomberImg));
					b.pSquads.add(new pSquad(425, 475, 3, Color.RED, pBomberImg));
					b.pSquads.add(new pSquad(550, 525, 2, Color.GREEN, pFighterImg));
					b.pSquads.add(new pSquad(650, 550, 1, Color.YELLOW, pScramblerImg));
					
					b.eSquads.add(new eSquad(350, 125, 5, eCannonImg));
					b.eSquads.add(new eSquad(450, 125, 5, eCannonImg));
					b.eSquads.add(new eSquad(700, 100, 3, eEliteImg));
					b.eSquads.add(new eSquad(100, 100, 3, eEliteImg));

					b.save();
				} 
				break;
			case STORY41: g.drawImage(story41,0,0,this); 
				if(leftClicked) 
				{ 
					scene = StoryScene.STORY51;
					mode = Mode.BATTLE; 
					//set up mission
					b = new Battle();

					b.pSquads.add(new pSquad(200, 450, 1, Color.BLUE, pScramblerImg));
					b.pSquads.add(new pSquad(200, 525, 3, Color.RED, pBomberImg));
					b.pSquads.add(new pSquad(600, 525, 4, Color.GRAY, pResilientImg));
					b.pSquads.add(new pSquad(400, 525, 2, Color.GREEN, pFighterImg));
					
					b.eSquads.add(new eSquad(550, 150, 4, eStationImg));
					b.eSquads.add(new eSquad(250, 100, 2, eBomberImg));
					b.eSquads.add(new eSquad(350, 100, 1, eFighterImg));

					b.save();
				} 
				break;
			case STORY51: g.drawImage(story51,0,0,this); 
				if(leftClicked) 
				{ 
					scene = StoryScene.STORY61;
					mode = Mode.BATTLE; 
					//set up mission
					b = new Battle();
					
					b.pSquads.add(new pSquad(100, 500, 2, Color.GREEN, pFighterImg));
					b.pSquads.add(new pSquad(200, 525, 3, Color.CYAN, pBomberImg));
					b.pSquads.add(new pSquad(300, 475, 4, Color.GRAY, pResilientImg));
					b.pSquads.add(new pSquad(350, 550, 1, Color.MAGENTA, pScramblerImg));
					b.pSquads.add(new pSquad(400, 525, 5, Color.RED, pAspImg));
					b.pSquads.add(new pSquad(450, 550, 1, Color.YELLOW, pScramblerImg));
					b.pSquads.add(new pSquad(500, 475, 4, Color.GREEN.darker().darker(), pResilientImg));
					b.pSquads.add(new pSquad(600, 525, 3, Color.RED.darker().darker(), pBomberImg));
					b.pSquads.add(new pSquad(700, 500, 2, Color.BLUE, pFighterImg));
					
					b.eSquads.add(new eSquad(600, 150, 5, eCannonImg));
					b.eSquads.add(new eSquad(400, 100, 2, eBomberImg));
					b.eSquads.add(new eSquad(200, 150, 4, eStationImg));
					b.eSquads.add(new eSquad(150, 100, 1, eFighterImg));
					b.eSquads.add(new eSquad(650, 100, 1, eFighterImg));
					b.eSquads.add(new eSquad(300, 125, 3, eEliteImg));
					b.eSquads.add(new eSquad(500, 125, 3, eEliteImg));

					b.save();
				} 
				break;
			case STORY61: g.drawImage(story61,0,0,this); 
				if(leftClicked) 
				{ 
					// win
					mode = Mode.MAINMENU; 
					campaign = false;
				}
				break;
		}
		
		paintAll();
	}

	private void tickBattle(int step)
	{
		calcBattle(step);
		displayBattle();
	}

	private void calcBattle(int step)
	{
		switch(tutorial)
		{
			case 1:
				if(leftClicked && !b.paused || turnOver) // time to switch scenes
				{
					tutorial++;

					b = new Battle(); 
					b.eSquads.add(new eSquad(700, 75, 1, eFighterImg)); 
					pSquad ps = new pSquad(200, 525, 1, Color.RED, pScramblerImg);
					ps.waypoints.add(new Waypoint(750.0,50.0));
					ps.waypoints.add(new Waypoint(400.0,200.0));
					b.pSquads.add(ps);
					ps = new pSquad(700, 525, 2, Color.BLUE, pFighterImg);
					ps.waypoints.add(new Waypoint(100.0,525.0));
					b.pSquads.add(ps);
					
				}
				leftClicked = false;
				rightClicked = false; 
				leftTyped = false;
				rightTyped = false;
				deleteTyped = false;
				escapeTyped = false;
				break;
			case 2:
				if(leftClicked && !b.paused || turnOver) // time to switch scenes
				{
					tutorial++;

					b = new Battle(); 
					b.eSquads.add(new eSquad(500, 100, 1, eFighterImg));
					b.eSquads.add(new eSquad(300, 100, 1, eFighterImg));
					pSquad ps = new pSquad(400, 450, 4, Color.RED, pResilientImg);
					ps.waypoints.add(new Waypoint(400.0,200.0));
					b.pSquads.add(ps);
					ps = new pSquad(600, 525, 2, Color.BLUE, pFighterImg);
					ps.waypoints.add(new Waypoint(700.0,525.0));
					ps.waypoints.add(new Waypoint(350.0,150.0));
					b.pSquads.add(ps);
					ps = new pSquad(200, 525, 2, Color.GREEN, pFighterImg);
					ps.waypoints.add(new Waypoint(100.0,525.0));
					ps.waypoints.add(new Waypoint(500.0,200.0));
					b.pSquads.add(ps);
				}
				leftClicked = false;
				rightClicked = false; 
				leftTyped = false;
				rightTyped = false;
				deleteTyped = false;
				escapeTyped = false;
				break;
			case 3:
				if(leftClicked && !b.paused || turnOver) // time to switch scenes
				{
					tutorial++;

					b = new Battle(); 
					b.eSquads.add(new eSquad(500, 100, 1, eFighterImg));
					b.eSquads.add(new eSquad(300, 100, 1, eFighterImg));
					pSquad ps = new pSquad(400, 450, 4, Color.RED, pResilientImg);
					b.pSquads.add(ps);
					ps = new pSquad(600, 525, 2, Color.BLUE, pFighterImg);
					b.pSquads.add(ps);
					ps = new pSquad(200, 525, 2, Color.GREEN, pFighterImg);
					b.pSquads.add(ps);
				}
				leftClicked = false;
				rightClicked = false; 
				leftTyped = false;
				rightTyped = false;
				deleteTyped = false;
				escapeTyped = false;
				break;
			case 4:
				if(leftClicked && !b.paused || turnOver)
				{
					tutorial++;

					b = new Battle();
					b.eSquads.add(new eSquad(4000, 75, 1, eFighterImg));
					pSquad ps = new pSquad(4000, 525, 2, Color.RED, pFighterImg);
					b.pSquads.add(ps);
					leftClicked = false;
				}
				escapeTyped = false;
				break;
			case 5:
				if(leftClicked)
				{
					tutorial = 0;
					mode = Mode.MAINMENU;
				}
				leftClicked = false;
				rightClicked = false; 
				leftTyped = false;
				rightTyped = false;
				deleteTyped = false;
				spaceTyped = false;
				escapeTyped = false;
				break;
		}
		turnOver = false;

		title = "MENU";
		if(b.pSquads.size()==0)
		{
			battleMenu = true;
			title = "DEFEAT";
		}
		if(b.eSquads.size()==0)
		{
			battleMenu = true;
			title = "VICTORY";
		}
		if(escapeTyped && !battleMenu)
		{
			battleMenu = true;
			pausedSaved = b.paused;
			b.paused = true;
		}

		if(battleMenu)
		{
			spaceTyped = false;
			if(mouseY > 215 && mouseY < 260) 
			{ 	
				if(leftClicked) 
				{ 
					battleMenu = false; b.paused = true;
					if(campaign && title == "VICTORY") 
						mode = Mode.STORY; 
					else 
					{ 
						screen = MenuScreen.MAINMENU; 
						mode = Mode.MAINMENU; 
					}  								
				} 
			} // Back to Main / Continue

			if(mouseY > 265 && mouseY < 310) 
			{ 
				if(leftClicked) 
				{ 
					battleMenu = false; 
					b.reload(); 
				} 
			} // Restart

			if(title == "MENU" && mouseY > 315 && mouseY < 360) 
			{ 
				if(leftClicked) 
				{ 
					battleMenu = false; 
					b.paused = pausedSaved; 
					leftClicked = false; 
				} 
			} // Back
			leftClicked = false;
		}

		//check for pause
		if(b.paused)
		{
			if(spaceTyped) 
				b.paused = false;
		}
		else // unpaused
		{
			b.pauseTimer += step;
			if(b.pauseTimer >= b.turnLength && title == "MENU")
			{
				b.pauseTimer = 0;
				b.paused = true;
				turnOver = true;
			}
		}
		//handle input
		if(rightTyped)
		{
			currentSquadNum++;
		}
		else if(leftTyped)
		{
			currentSquadNum--;
		}

		if(currentSquadNum >= b.pSquads.size())
			currentSquadNum = 0;
		if(currentSquadNum < 0)
			currentSquadNum = b.pSquads.size()-1;

		double lowestDist = 1000000.0;
		int closestSquadNum = 0;
		if(rightClicked)
		{
			for(int i = 0; i < b.pSquads.size(); i++)
			{
				pSquad ps = b.pSquads.get(i);
				if( ( (ps.x - mouseX)*(ps.x - mouseX) + (ps.y - mouseY)*(ps.y - mouseY) ) < lowestDist)
				{
					lowestDist = ( (ps.x - mouseX)*(ps.x - mouseX) + (ps.y - mouseY)*(ps.y - mouseY) );
					closestSquadNum = i;
				}
			}
			currentSquadNum = closestSquadNum;
		}

		for(int i = 0; i < b.pSquads.size(); i++)
		{
			pSquad ps = b.pSquads.get(i);
			if(i == currentSquadNum && b.paused)
			{
				ps.selected = true;
				if(leftClicked)
				{
					ps.waypoints.add(new Waypoint(mouseX, mouseY));
				}
				if(deleteTyped)
				{
					int wptsSize = ps.waypoints.size();
					if(wptsSize > 0)
						ps.waypoints.remove(wptsSize - 1);
				}
			}
			else 
				ps.selected = false;

			if(!b.paused) //calc player squads
				if(ps.calc(b, step))
				{
					b.pSquads.remove(i);
					currentSquadNum--;
					if(currentSquadNum < 0)
						currentSquadNum = b.pSquads.size()-1;
					i--;
				}
		}

		if(!b.paused) 
		{
			for(int i = 0; i < b.eSquads.size(); i++) 
			{
				eSquad es = b.eSquads.get(i);
				// calc enemy squads
				if(es.calc(b, step))
				{
					b.eSquads.remove(i);
					i--;
				}
			}

			//calc player shots
			for(int i = 0; i < b.pShots.size(); i++)
			{
				Shot shot = b.pShots.get(i);
				if(shot.pcalc(step, b.eSquads)) // shot is dead
				{
					switch(shot.shotType)
					{
						case 1:
							b.explode(2, 3, shot.x, shot.y, 0.5, 600, 0.0, 0.0);
							break;
						case 2:
							b.explode(2, 30, shot.x, shot.y, 1.0, 1000, 0.0, 0.0);
							break;
					}
					b.pShots.remove(i);
					i--;
				}
			}

			//calc enemy shots
			for(int i = 0; i < b.eShots.size(); i++)
			{
				Shot shot = b.eShots.get(i);
				if(shot.ecalc(step, b.pSquads)) // shot is dead
				{
					switch(shot.shotType)
					{
						case 1:
							b.explode(3, 5, shot.x, shot.y, 0.5, 600, 0.0, 0.0);
							break;
						case 2:
							b.explode(3, 30, shot.x, shot.y, 1.0, 1000, 0.0, 0.0);
							break;
						case 3:
							b.explode(3, 50, shot.x, shot.y, 3.0, 1000, 0.0, 0.0);
							break;
					}
					b.eShots.remove(i);
					i--;
				}
			}

			// calc particles
			for(int i = 0; i < b.particles.size(); i++)
			{
				Particle p = b.particles.get(i);
				if(p.calc(step)) // particle is dead
				{
					b.particles.remove(i);
					i--;
				}
			}
		}
		else // not paused
		{
			if(rightMousePressed)
			{
				pSquad ps = b.pSquads.get(currentSquadNum);
				if(!displaySquadInfo && ( (ps.x - mouseX) * (ps.x - mouseX) + (ps.y - mouseY) * (ps.y - mouseY) )<2500 )
				{
					displaySquadInfo = true;
					displaySquadX = (int)ps.x -50;
					if(displaySquadX > 700) displaySquadX = 700;
					if(displaySquadX < 0) displaySquadX = 0;
					displaySquadY = (int)ps.y - 200;
					if(displaySquadY < 0) displaySquadY = (int)ps.y + 50;
				}
			}
			else
			{
				displaySquadInfo = false;
			}
		}
	}

	private void displayBattle()
	{
		// background
		g.drawImage(background,0,0,this);

		g.setFont(new Font("Serif", Font.BOLD, 20));

		// background data
		g.setColor(Color.WHITE);
		int currentCount = ((int)b.turnLength - (int)b.pauseTimer); if (currentCount<0) currentCount = 0;
		g.drawString(""+currentCount, 700, 50);
		//g.drawString("FPS: "+fps, 700, 75);

		// paint player shots
		for(Shot shot : b.pShots)
		{
			BufferedImage shotImage;
			switch(shot.shotType)
			{
				case 1: // pshot
					shotImage = pShotImg;
					break;
				case 2: // bomb
					shotImage = pBombImg;
					break;
				default: shotImage = pShotImg;
			}
			g.drawImage(shotImage, (int)shot.x - (shot.size/2), (int)shot.y - (shot.size/2), this);
		}

		// paint enemy shots
		for(Shot shot : b.eShots)
		{
			BufferedImage shotImage;
			switch(shot.shotType)
			{
				case 1: // eshot
					shotImage = eShotImg;
					break;
				case 2: // bomb
					shotImage = eBombImg;
					break;
				case 3: // cannon shell
					shotImage = eShellImg;
					break;
				default: shotImage = eShotImg;
			}
			g.drawImage(shotImage, (int)shot.x - (shot.size/2), (int)shot.y - (shot.size/2), this);
		}

		for(pSquad ps : b.pSquads)
		{
			// circles around squads
			if(ps.selected && b.paused)
			{
				g.setColor(ps.color);
				g.setStroke(new BasicStroke(10));
				g.drawOval( (int)ps.x-45, (int)ps.y-45, 90, 90);
			}

			// squad background;
			g.setColor(ps.tColor);
			g.fillOval( (int)ps.x-45, (int)ps.y-45, 90, 90);

			double x = ps.x;
			double y = ps.y;
			// waypoints		
			for(int i = 0; i < ps.waypoints.size(); i++)
			{
				g.setColor(ps.color);
				Waypoint waypoint = (Waypoint)ps.waypoints.get(i);
				if(i == 0) // for first waypoint, draw a line to it
				{
					if(ps.selected)
						g.setStroke(new BasicStroke(5));
					else
						g.setStroke(new BasicStroke(1));
					g.drawLine((int)x, (int)y, (int)waypoint.x, (int)waypoint.y);
				}
				if(ps.selected)
				{
					g.setStroke(new BasicStroke(1));
					g.drawLine((int)x, (int)y, (int)waypoint.x, (int)waypoint.y);
					x = waypoint.x;	
					y = waypoint.y;
				}
				if(waypoint.reached) g.setColor(ps.color.darker().darker());
				g.fillOval((int)waypoint.x - 15, (int)waypoint.y - 15, 30, 30);
				g.setColor(Color.WHITE);
				g.drawString(""+(i+1), (int)waypoint.x - (fontmet.stringWidth(""+(i+1)) / 2), (int)waypoint.y + 7);
			}
		}

		// deal with player squads
		for(pSquad ps : b.pSquads)
		{
			int size = ps.size * 2;
			boolean mouseover = (((ps.x-mouseX)*(ps.x-mouseX) + (ps.y-mouseY)*(ps.y-mouseY)) <= 2500.0);
			BufferedImage rotatedImage = new BufferedImage(size, size, BufferedImage.TYPE_INT_ARGB);
			Graphics2D g2 = rotatedImage.createGraphics();

			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_ENABLE);        												
			g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

			g2.rotate(ps.r, size/2, size/2);
			g2.drawImage(ps.shipImage, (size - ps.size)/2, (size - ps.size)/2, this);

			for(Ship ship : ps.ships)
			{
				g.drawImage(rotatedImage, (int)(ps.x + ship.osx)-(size/2), (int)(ps.y + ship.osy)-(size/2), this);

				if(mouseover)
				{// health goes from 1 to 0, i want green to go from 2 to 0, i want red to go from 0 to 2
					g.setColor(Color.DARK_GRAY);
					g.fillRect((int)(ps.x + ship.osx)-(ps.size/2), (int)(ps.y + ship.osy)+(ps.size/2), ps.size, 5);
					float health = (float)ship.health / (float)ship.maxhealth; if(health<=0) health = 0;
					float green = (float)1.8 - 2*(1-health); if(green < 0) green = 0; if(green>1) green = 1;
					float red = (float)2*(1-health); if(red < 0) red = 0; if(red>1) red = 1;
					g.setColor(new Color(red, green, 0));
					g.fillRect((int)(ps.x + ship.osx)-(ps.size/2)+1, (int)(ps.y + ship.osy)+(ps.size/2)+1, (int)(health*ps.size)-2, 3);
				}

				//g.fillRect((int)(ps.x + ship.osx)-1, (int)(ps.y + ship.osy)-1,2,2); // ship center dot
			}
			//g.fillOval((int)(ps.x)-2, (int)(ps.y)-2,4,4); // squad center dot
		}
		
		// deal with enemy squads
		for(eSquad es : b.eSquads) 
		{
			boolean mouseover = (((es.x-mouseX)*(es.x-mouseX) + (es.y-mouseY)*(es.y-mouseY)) <= 2500.0);
			int size = es.size * 2;
			BufferedImage rotatedImage = new BufferedImage(size, size, BufferedImage.TYPE_INT_ARGB);
			Graphics2D g2 = rotatedImage.createGraphics();

			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_ENABLE);        												
			g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

			g2.rotate(es.r, size/2, size/2);
			g2.drawImage(es.shipImage, (size - es.size)/2, (size - es.size)/2, this);

			for(Ship ship : es.ships)
			{
				g.drawImage(rotatedImage, (int)(es.x + ship.osx)-(size/2), (int)(es.y + ship.osy)-(size/2), this);
				//g.fillRect((int)(ps.x + ship.osx)-1, (int)(ps.y + ship.osy)-1,2,2); // ship center dot

				if(mouseover)
				{// health goes from 1 to 0, i want green to go from 2 to 0, i want red to go from 0 to 2
					g.setColor(Color.DARK_GRAY);
					g.fillRect((int)(es.x + ship.osx)-(es.size/2), (int)(es.y + ship.osy)+(es.size/2), es.size, 5);
					float health = (float)ship.health / (float)ship.maxhealth; if(health<=0) health = 0;
					float green = (float)1.8 - 2*(1-health); if(green < 0) green = 0; if(green>1) green = 1;
					float red = (float)2*(1-health); if(red < 0) red = 0; if(red>1) red = 1;
					g.setColor(new Color(red, green, 0));
					g.fillRect((int)(es.x + ship.osx)-(es.size/2)+1, (int)(es.y + ship.osy)+(es.size/2)+1, (int)(health*(es.size-2)), 3);
				}
			}
			//g.fillOval((int)(ps.x)-2, (int)(ps.y)-2,4,4); // squad center dot
		}

		// display particles
		for(Particle p : b.particles)
		{
			int psize = 0;
			BufferedImage pimage = explosionSmallImg;
			switch(p.type)
			{
				case 0:
					psize = 20;
					pimage = bloodSmallImg;
					break;
				case 1:
					psize = 20;
					pimage = explosionSmallImg;
					break;
				case 2:
					psize = 5;
					pimage = eDebris;
					break;
				case 3:
					psize = 5;
					pimage = pDebris;
					break;
				case 4:
					psize = 50;
					pimage = explosionLargeImg;
					break;
			}
			g.drawImage(pimage, (int)p.x - (psize/2), (int)p.y - (psize/2), this);
		}


		if(battleMenu)
		{
			g.setColor(new Color(0,0,0,0.5f));
			g.fillRect(0,0,800,600);
			FontMetrics fmetric;
			// menu title
			g.setFont(new Font("SANS_SERIF", Font.BOLD, 60));
			fmetric = g.getFontMetrics();
			g.setColor(myPurple);
			g.drawString(title, 400-(fmetric.stringWidth(title) / 2), 100);

			g.setFont(new Font("SANS_SERIF", Font.BOLD, 40));
			fmetric = g.getFontMetrics();
			g.setColor(myPurple);

			if(mouseY > 215 && mouseY < 260) 
			{ 
				g.setColor(Color.WHITE); 
			}

			if(campaign && title == "VICTORY") 
				g.drawString("Continue", 400-(fmetric.stringWidth("Continue") / 2), 250);
			else 
				g.drawString("Quit to Main", 400-(fmetric.stringWidth("Quit to Main") / 2), 250);
			
			g.setColor(myPurple);

			if(mouseY > 265 && mouseY < 310) 
			{ 
				g.setColor(Color.WHITE); 
			}
			g.drawString("Restart", 400-(fmetric.stringWidth("Restart") / 2), 300);
			g.setColor(myPurple);

			if(title == "MENU" && mouseY > 315 && mouseY < 360) 
			{ 
				g.setColor(Color.WHITE); 
			}

			if(title == "MENU") 
				g.drawString("Back", 400-(fmetric.stringWidth("Back") / 2), 350);
		}

		if(displaySquadInfo)
		{
			pSquad ps = b.pSquads.get(currentSquadNum);

			// squad background;
			g.setColor(Color.BLACK);
			g.fillOval( (int)ps.x-45, (int)ps.y-45, 90, 90);

			// circles around squads
			g.setColor(ps.color);
			g.setStroke(new BasicStroke(10));
			g.drawOval( (int)ps.x-45, (int)ps.y-45, 90, 90);

			int size = ps.size * 2;
			BufferedImage rotatedImage = new BufferedImage(size, size, BufferedImage.TYPE_INT_ARGB);
			Graphics2D g2 = rotatedImage.createGraphics();

			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
			g2.setRenderingHint(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_ENABLE);        												
			g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

			g2.rotate(ps.r, size/2, size/2);
			g2.drawImage(ps.shipImage, (size - ps.size)/2, (size - ps.size)/2, this);

			for(Ship ship : ps.ships)
			{
				g.drawImage(rotatedImage, (int)(ps.x + ship.osx)-(size/2), (int)(ps.y + ship.osy)-(size/2), this);

				g.setColor(Color.DARK_GRAY);
				g.fillRect((int)(ps.x + ship.osx)-(ps.size/2), (int)(ps.y + ship.osy)+(ps.size/2), ps.size, 5);
				float health = (float)ship.health / (float)ship.maxhealth; if(health<=0) health = 0;
				float green = (float)1.8 - 2*(1-health); if(green < 0) green = 0; if(green>1) green = 1;
				float red = (float)2*(1-health); if(red < 0) red = 0; if(red>1) red = 1;
				g.setColor(new Color(red, green, 0));
				g.fillRect((int)(ps.x + ship.osx)-(ps.size/2)+1, (int)(ps.y + ship.osy)+(ps.size/2)+1, (int)(health*ps.size)-2, 3);
			}
		
			g.setStroke(new BasicStroke(5));
			g.setColor(Color.BLACK);
			g.fillRect(displaySquadX, displaySquadY, 100, 150);
			g.setColor(Color.WHITE);
			g.drawRect(displaySquadX, displaySquadY, 100, 150);
			g.setStroke(new BasicStroke(1));
			g.drawImage(ps.shipImage, displaySquadX + 26, displaySquadY + 10, 50, 50, this);
			g.drawRect(displaySquadX + 20, displaySquadY + 5, 61, 60);

			g.setColor(ps.color);
			//display information

			switch(ps.shipType)
			{
				case 1:
					g.setFont(new Font("SANS_SERIF", Font.BOLD, 12));
					g.drawString("Scout: " + ps.ships.size() + "/16", displaySquadX+10, displaySquadY+80);
					g.setFont(new Font("SANS_SERIF", Font.PLAIN, 10));
					g.drawString("Fast, agile, and", displaySquadX+10, displaySquadY+100);
					g.drawString("very weak.", displaySquadX+10, displaySquadY+110);
					g.drawString("Fires single shots", displaySquadX+10, displaySquadY+120);
					g.drawString("at large intervals.", displaySquadX+10, displaySquadY+130);
					g.drawString("Good diversions.", displaySquadX+10, displaySquadY+140);
					break;
				case 2:
					g.setFont(new Font("SANS_SERIF", Font.BOLD, 12));
					g.drawString("Worker: " + ps.ships.size() + "/9", displaySquadX+10, displaySquadY+80);
					g.setFont(new Font("SANS_SERIF", Font.PLAIN, 10));
					g.drawString("Standard fighter.", displaySquadX+10, displaySquadY+100);
					g.drawString("Fires at fast pace,", displaySquadX+10, displaySquadY+110);
					g.drawString("but lacks armor.", displaySquadX+10, displaySquadY+120);
					g.drawString("A prime offensive", displaySquadX+10, displaySquadY+130);
					g.drawString("tool.", displaySquadX+10, displaySquadY+140);
					break;
				case 3:
					g.setFont(new Font("SANS_SERIF", Font.BOLD, 12));
					g.drawString("Soldier: " + ps.ships.size() + "/4", displaySquadX+10, displaySquadY+80);
					g.setFont(new Font("SANS_SERIF", Font.PLAIN, 10));
					g.drawString("Shoots extremely", displaySquadX+10, displaySquadY+100);
					g.drawString("powerful shots at", displaySquadX+10, displaySquadY+110);
					g.drawString("close range.", displaySquadX+10, displaySquadY+120);
					g.drawString("Very, very useful.", displaySquadX+10, displaySquadY+130);
					g.drawString("Protect these.", displaySquadX+10, displaySquadY+140);
					break;
				case 4:
					g.setFont(new Font("SANS_SERIF", Font.BOLD, 12));
					g.drawString("Carapace: " + ps.ships.size() + "/4", displaySquadX+10, displaySquadY+80);
					g.setFont(new Font("SANS_SERIF", Font.PLAIN, 10));
					g.drawString("Weak on offense,", displaySquadX+10, displaySquadY+100);
					g.drawString("but takes great", displaySquadX+10, displaySquadY+110);
					g.drawString("damage. Thick", displaySquadX+10, displaySquadY+120);
					g.drawString("armor makes an", displaySquadX+10, displaySquadY+130);
					g.drawString("ideal decoy.", displaySquadX+10, displaySquadY+140);
					break;
				case 5:
					g.setFont(new Font("SANS_SERIF", Font.BOLD, 12));
					g.drawString("Queen: " + ps.ships.size() + "/1", displaySquadX+10, displaySquadY+80);
					g.setFont(new Font("SANS_SERIF", Font.PLAIN, 10));
					g.drawString("Centerpiece of", displaySquadX+10, displaySquadY+100);
					g.drawString("an Asp swarm.", displaySquadX+10, displaySquadY+110);
					g.drawString("Immensely strong,", displaySquadX+10, displaySquadY+120);
					g.drawString("and fierce when", displaySquadX+10, displaySquadY+130);
					g.drawString("attacking.", displaySquadX+10, displaySquadY+140);
					break;
			}

		}

		//painting for tutorial
		g.setFont(new Font("SANS_SERIF", Font.PLAIN, 20));
		g.setColor(myPurple);
		switch(tutorial)
		{
			case 1:
				if(b.paused) 
				{
					g.drawString("Welcome to the Asp Tutorial!", 50, 65);
					g.drawString("Asp is a game of fleet combat", 50, 100);
					g.drawString("between aliens (you!) and humans.", 50, 125);
					g.drawString("All the ships in the game will shoot", 50, 150);
					g.drawString("straight ahead if there is an enemy", 50, 175);
					g.drawString("in their line of sight. Press SPACE", 50, 200);
					g.drawString("to watch your aliens attack the bombers.", 50, 225);
				}
				else g.drawString("Click to skip", 650, 580);
				break;
			case 2:
				if(b.paused) 
				{
					g.drawString("Your ships will follow waypoints, as you've seen.", 50, 65);
					g.drawString("The human ships, however, will just", 50, 100);
					g.drawString("follow a target as best as they can.", 50, 125);
					g.drawString("They'll lock onto the closest enemy", 50, 150);
					g.drawString("squad and tail them doggedly.", 50, 175);
					g.drawString("Here, the human fighters will", 50, 225);
					g.drawString("attack your squad in the lower-right.", 50, 250);
					g.drawString("But! If your other ships get close enough,", 50, 275);
					g.drawString("the fighters will switch targets. Press", 50, 300);
					g.drawString("SPACE to watch your scouts distract", 50, 325);
					g.drawString("the fighters.", 50, 350);
				}
				else g.drawString("Click to skip", 650, 580);
				break;
			case 3:
				if(b.paused) 
				{
					g.drawString("Often, a diversion is helpful.", 50, 175);
					g.drawString("Here, your strong Carapace ships", 50, 200);
					g.drawString("will distract the two human ", 50, 225);
					g.drawString("fighter squads.", 50, 250);
					g.drawString("Meanwhile, your fighters will", 50, 275);
					g.drawString("get in position to deliver a ", 50, 300);
					g.drawString("devastating attack!", 50, 325);
					g.drawString("Press SPACE to watch this plan", 50, 350);
					g.drawString("go into action.", 50, 375);
				}
				else g.drawString("Click to skip", 650, 580);
				break;
			case 4:
				if(b.paused)
				{
					g.drawString("Time to give your own orders!", 50, 150);
					g.drawString("Click to place a waypoint.", 50, 200);
					g.drawString("Backspace to remove last waypoint.", 50, 235);
					g.drawString("Right-click or Left/Right Arrows", 50, 270);
					g.drawString("to select a new squad.", 50, 295);
					g.drawString("Right-click (hold) selected squad", 50, 330);
					g.drawString("to get squad info.", 50, 355);
					g.drawString("Esc to access menu (disabled in tutorial).", 50, 390);
					g.drawString("SPACE to start the turn.", 50, 425);
				}
				else g.drawString("Click to skip", 650, 580);
				break;
			case 5:
				if(b.paused) 
				{
					g.drawString("That's all for the tutorial!", 50, 150);
					g.drawString("In full games, you'll have a chance to give new orders", 50, 200);
					g.drawString("each time the timer in the upper-right reaches 0.", 50, 225);
					g.drawString("Remember, all ships shoot only if there are enemies in their", 50, 275);
					g.drawString("line-of-sight, and human ships will target and follow whichever", 50, 300);
					g.drawString("squad is closest to them. Use diversions and decoys to position", 50, 325);
					g.drawString("your enemies, and take them out with your best firepower!", 50, 350);
					g.drawString("Good luck! Click to return to the main menu.", 50, 400);
				}
				break;
		}


		paintAll();
	}
// main game loop

	private class Listener implements ActionListener
	{
		long oldtime = System.nanoTime();
		long newtime;
		long timedif;
		long kepttime = System.nanoTime();

		public void actionPerformed(ActionEvent e)
		{
			newtime = System.nanoTime();
			timedif = newtime - oldtime;

			timedif /= 1000000; // converts to millis

			while(timedif < 16) // min tick
			{
				Thread.yield();
				newtime = System.nanoTime();
				timedif = newtime - oldtime;
				timedif /= 1000000;
			}
			times++;

			if(timedif > 100) timedif = 100; // max tick

			tick((int)timedif);

			if(times >= 10)
			{
				fps = (double)times / ((newtime - kepttime) / 1000000000.0);
				//System.out.println(""+times+" / ((" + newtime + " - " + kepttime + ") / 1000000000.0)  = " + fps);
				kepttime = newtime;
				times = 0;
			}

			oldtime = newtime;
		}
	}



	//User Input classes:
	private class KeyInputHandler extends KeyAdapter {
		public void keyPressed(KeyEvent e) 
		{
			//check for key input
		
			if (e.getKeyCode() == KeyEvent.VK_ESCAPE) 
			{
				escapeTyped = true;
			}
			if (e.getKeyCode() == KeyEvent.VK_SPACE) 
			{
				spaceTyped = true;
			}
			if (e.getKeyCode() == KeyEvent.VK_BACK_SPACE) 
			{
				deleteTyped = true;
			}
			if (e.getKeyCode() == KeyEvent.VK_RIGHT) 
			{
				rightTyped = true;
			}
			if (e.getKeyCode() == KeyEvent.VK_LEFT) 
			{
				leftTyped = true;
			}
		} 
	    
	}
	      
	private class MouseInputHandler implements MouseListener
	{
		      
		public void mousePressed(MouseEvent e)
		{
			if(e.getButton() == MouseEvent.BUTTON3)
				rightMousePressed = true;
			else
				leftMousePressed = true;
		}
		      
		public void mouseReleased(MouseEvent e)
		{
			if(e.getButton() == MouseEvent.BUTTON3)
			{
				rightMousePressed = false;
				rightClicked=true;
			}
			else
			{
				leftMousePressed = false;
				leftClicked=true;
			
			}
		}
		      
		public void mouseEntered(MouseEvent e)
		{
			 
		}
		      
		public void mouseExited(MouseEvent e) 
		{
			    
			    
		}
		      
		public void mouseClicked(MouseEvent e)
		{
			//leftClicked=true;
		}      
		       
	}
	   
	private class MouseMotionHandler extends MouseMotionAdapter
	{
		public void mouseDragged(MouseEvent e)
		{
			mouseX = e.getX();
			mouseY = e.getY();

			if(e.getButton() == MouseEvent.BUTTON3)
				rightMousePressed = true;
			else
				leftMousePressed = true;
		}
		public void mouseMoved(MouseEvent e)
		{
			mouseX = e.getX();
			mouseY = e.getY();
		}
	}


}

