import java.util.ArrayList;
import java.awt.*;
import java.awt.image.*;

public abstract class Squad
{
	public int shipType;
	public int value;
	public double x = 100; 
	public double y = 100;
	public int size = 100;
	public double r = 0.5;
	public double turnSpeed = 0.0;
	public double speed = 0.0;
	public ArrayList<Ship> ships = new ArrayList<Ship>();
	public BufferedImage shipImage;

	protected void initVars()
	{
		Ship exampleShip = ships.get(0);
		turnSpeed = exampleShip.turnSpeed;
		size = exampleShip.size;
		speed = exampleShip.speed;
		value = exampleShip.value;
	}

	abstract boolean calc(Battle b, int step);

}




