import java.awt.geom.*;

public class pAsp extends Ship
{
	public static int svalue = 500;
	public pAsp(double offsetx2, double offsety2)
	{
		//ship type vars
		health = 500;
		maxhealth = health;
		turnSpeed = 0.0015;
		size = 50;
		speed = 0.05;
		shotDelay = 50;
		explosionPower = 5.0;
		value = svalue;
		offsetx = offsetx2;
		offsety = offsety2;
		osx = offsetx2;
		osy = offsety2;
	}

	public boolean calc(Battle b, Squad mySquad, int step)
	{
		if(health<=0) return true;

		// CHECK FOR SHOTS

		shotPause += step;
		if(shotPause >= shotDelay) // ready to shoot
		{
			double myx = mySquad.x + osx;
			double myy = mySquad.y + osy;
			double myr = mySquad.r;

			Line2D.Double los = new Line2D.Double( myx, myy, Math.sin(myr)*10000.0 + myx, Math.cos(myr)*-10000.0 + myy);

			for(eSquad es : b.eSquads)
			{
				for(Ship ship : es.ships)
				{
					double shipx = es.x + ship.osx;
					double shipy = es.y + ship.osy;
					double sizebox = ship.size * 0.8;
					if(los.intersects (shipx - (sizebox/2), shipy - (sizebox/2), sizebox, sizebox))
					{
						b.pShots.add(new Shot(1, myx + 8*Math.cos(myr), myy + 8*Math.sin(myr), Math.cos(myr - Math.PI/2)*0.2, Math.sin(myr - Math.PI/2)*0.2, 5, 1));
						b.pShots.add(new Shot(1, myx - 8*Math.cos(myr), myy - 8*Math.sin(myr), Math.cos(myr - Math.PI/2)*0.2, Math.sin(myr - Math.PI/2)*0.2, 5, 1));
						shotPause = 0;
					}
				}
			}
		}
		return false;
	}
}



