import java.awt.geom.*;

public class pResilient extends Ship
{
	public static int svalue = 200;
	public pResilient(double offsetx2, double offsety2)
	{
		//ship type vars
		health = 150;
		maxhealth = health;
		turnSpeed = 0.002;
		size = 20;
		speed = 0.07;
		shotDelay = 750;
		explosionPower = 2.0;
		value = svalue;

		offsetx = offsetx2;
		offsety = offsety2;
		osx = offsetx2;
		osy = offsety2;
	}

	public boolean calc(Battle b, Squad mySquad, int step)
	{
		if(health<=0) return true;

		// SHIP DRIFT
		driftx += (Math.random() - 0.5) * 0.01 * (double)step;
		drifty += (Math.random() - 0.5) * 0.01 * (double)step;
		driftx *= 0.95;
		drifty *= 0.95;
		driftx -= 0.005 * (osx - offsetx);
		drifty -= 0.005 * (osy - offsety);
		osx += driftx;
		osy += drifty;

		// CHECK FOR SHOTS

		shotPause += step;
		if(shotPause >= shotDelay) // ready to shoot
		{
			double myx = mySquad.x + osx;
			double myy = mySquad.y + osy;
			double myr = mySquad.r;

			Line2D.Double los = new Line2D.Double( myx, myy, Math.sin(myr)*10000.0 + myx, Math.cos(myr)*-10000.0 + myy);

			for(eSquad es : b.eSquads)
			{
				for(Ship ship : es.ships)
				{
					double shipx = es.x + ship.osx;
					double shipy = es.y + ship.osy;
					double sizebox = ship.size * 0.8;
					if(los.intersects (shipx - (sizebox/2), shipy - (sizebox/2), sizebox, sizebox))
					{
						b.pShots.add(new Shot(1, myx, myy, Math.cos(myr - Math.PI/2)*0.2, Math.sin(myr - Math.PI/2)*0.2, 5, 1));
						shotPause = 0;

					}
				}
			}
		}
		return false;
	}

}


