

public class Particle
{
	public double x;
	public double y;
	public double xspeed;
	public double yspeed;
	public double shipxspeed;
	public double shipyspeed;
	public int size;
	public int type;
	public int duration;

	public Particle(int type2, double x2, double y2, double xspeed2, double yspeed2, int duration2, double shipx, double shipy)
	{
		type = type2;
		x = x2 + xspeed2*5;
		y = y2 + yspeed2*5;
		xspeed = xspeed2/50;
		yspeed = yspeed2/50;
		duration = duration2;
		shipxspeed = shipx;
		shipyspeed = shipy;
		
	}

	public boolean calc(int step)
	{
		duration-=step;
		if(duration < 0) return true;

		x += xspeed*step + shipxspeed*step;
		y += yspeed*step + shipyspeed*step;
	
		shipxspeed *= .8+(0.2*Math.random());
		shipyspeed *= .8+(0.2*Math.random());

		return false;
	}



}





