import java.awt.geom.*;

public class eCannon extends Ship
{
	public static int svalue = 400;
	public eCannon(double offsetx, double offsety)
	{
		//ship type vars
		health = 250;
		maxhealth = health;
		turnSpeed = 0.01;
		size = 40;
		speed = 0.0;
		shotDelay = 3000;
		explosionPower = 4.0;
		value = svalue;

		osx = offsetx;
		osy = offsety;
	}

	public boolean calc(Battle b, Squad mySquad, int step)
	{
		if(health<=0) return true;



		// CHECK FOR SHOTS
		shotPause += step;
		if(shotPause >= shotDelay) // ready to shoot
		{
			double myx = mySquad.x + osx;
			double myy = mySquad.y + osy;
			double myr = mySquad.r;

			Line2D.Double los = new Line2D.Double( myx, myy, Math.sin(myr)*10000.0 + myx, Math.cos(myr)*-10000.0 + myy);

			for(pSquad ps : b.pSquads)
			{
				for(Ship ship : ps.ships)
				{
					double shipx = ps.x + ship.osx;
					double shipy = ps.y + ship.osy;
					double sizebox = ship.size * 0.8;
					if(los.intersects (shipx - (sizebox/2), shipy - (sizebox/2), sizebox, sizebox))
					{
						b.eShots.add(new Shot(3, myx, myy, Math.cos(myr - Math.PI/2)*0.5, Math.sin(myr - Math.PI/2)*0.5, 10, 100));
						shotPause = 0;
					}
				}
			}
		}

		return false;
	}

}
